<?php
if ( ! current_user_can ( 'manage_options' ) ) {
	wp_die ( 'You do not have sufficient permissions to access this page.' );
}
$options = get_option( 'cnhk_options' );
if ( ! is_array( $options ) || 10 != count( $options ) ) {
	wp_die ( "<p class='error'>Data corrupted. Cnhk Slideshow must be reinstalled.</p>" );
}

$error_notice = '';
$success_notice = '';

if ( isset( $_POST['cnhk_token_new_ss'] ) && isset( $_SESSION['cnhk']['token_new_ss'] ) && $_POST['cnhk_token_new_ss'] == $_SESSION['cnhk']['token_new_ss'] )  {
	
	$name = trim( $_POST['name'] );
	$pattern = "#^[\p{L}0-9\.?\!_ -]{2,}$#iu";
	if ( preg_match( $pattern, $name ) == 1) {
		$sch = array( "#(\s){1,}#iu", "#[éêèë]#iu", "#[îï]#iu", "#[öô]#iu", "#[ùüû]#iu", "#[àâä]#iu", "#[ç]#iu", "#[^éêèëïîöôùüûàâäç0-9a-zA-Z_ -]#iu" );
		$rpl = array( "_", "e", "i", "o", "u", "a", "c", "-" );
		$name = preg_replace( $sch, $rpl, $name );
		
		$setting = get_option( 'cnhk_options' );

		if ( ! in_array( $name, $setting[0] ) ) {
		
			array_push( $setting[0], $name );
			array_push( $setting[1], 'Scroll' );
			array_push( $setting[2], 1000 );
			array_push( $setting[3], 4000 );
			array_push( $setting[4], 220 );
			array_push( $setting[5], 956 );
			array_push( $setting[6], true );
			array_push( $setting[7], false );
			array_push( $setting[8], null );
			array_push( $setting[9], null );
			
			update_option( 'cnhk_options', $setting );
			
			$ss = get_option( 'cnhk_options_ss' );
			array_push( $ss['ss'], $name );
			array_push( $ss['elem'], array() );
			update_option( 'cnhk_options_ss', $ss );
			
		} else {
			$error_notice .= "This name is already used for another slideshow. <strong>No data updated</strong><br />";
		}
		
	} else {
		if ( empty( $name ) ) {
			$error_notice .= "Slideshow's name must not be <strong>empty</strong><br />";
		} else {
			$error_notice .= "Slideshow's name can not contains any special characters. <strong>No data updated</strong><br />";
		}
	}
}

if ( isset( $_POST['cnhk_token_setting'] ) && ( $_SESSION['cnhk']['token_setting'] ) && $_POST['cnhk_token_setting'] == $_SESSION['cnhk']['token_setting'] ) {
	$index = intval( trim( $_GET['index'] ) );
	$effect_list = array( 'Scroll', 'Fade', 'None' );
	$effect = trim( $_POST['effect'] );
	$transition_speed = intval( trim( $_POST['transition_speed'] ) );
	$slide_duration = intval( trim( $_POST['slide_duration'] ) );
	$height = intval( trim( $_POST['height'] ) );
	$width = intval( trim( $_POST['width'] ) );
	
	$setting = get_option( 'cnhk_options' );
	
	if ( $index < count( $setting[0] ) ) {
		if ( ! in_array( $effect, $effect_list ) ) {
			$error_notice .= " - Choose a valid effect <br />";
		}
		if ( ! is_numeric( $_POST['transition_speed'] ) ) {
			$error_notice .= " - Transition speed must be an integer <br />";
		}
		if ( ! is_numeric( $_POST['slide_duration'] ) ) {
			$error_notice .= " - Slide duration must be an integer <br />";
		}
		if ( ! is_numeric( $_POST['height'] ) ) {
			$error_notice .= " - Height must be an integer <br />";
		}
		if ( ! is_numeric( $_POST['width'] ) ) {
			$error_notice .= " - Width must be an integer <br />";
		}
		
		$fixed = ( isset( $_POST['fixed'] ) && 1 == intval( trim( $_POST['fixed'] ) ) ) ? true : false;
		$fixed_width = null;
		$fixed_align = null;
		
		if ( isset( $_POST['fixed'] ) && 1 == intval( trim( $_POST['fixed'] ) ) ) {
			$fixed_align = trim( $_POST['fixed-align'] );
			if ( ! is_numeric( $_POST['fixed-width'] ) ) {
				$error_notice .= ' - Fixed width must be an integer.<br />';
			}
			$fixed_width = intval( trim( $_POST['fixed-width'] ) );
			$align_list = array( 'none', 'left', 'right', 'center', 'float-left', 'float-right' );			
			if ( ! in_array( $fixed_align, $align_list ) ) {
				$error_notice .= " - Choose a valid alignment <br />";
			}
		}
	
		if ( '' == $error_notice ) {
			$setting[1][$index] = $effect;
			$setting[2][$index] = $transition_speed;
			$setting[3][$index] = $slide_duration;
			$setting[4][$index] = $height;
			$setting[5][$index] = $width;
			$ckbox = ( isset( $_POST['nav'] ) && true == $_POST['nav'] ) ? true : false;
			$setting[6][$index] = $ckbox;
			$setting[7][$index] = $fixed;
			$setting[8][$index] = $fixed_width;
			$setting[9][$index] = $fixed_align;
			
			update_option( 'cnhk_options', $setting );
			$success_notice .= "<p>Data saved</p>";			
		} else {
			$error_notice .= "<strong><p>No data updated</p></strong>";	
		}
	
	} else {
		$error_notice .= "<strong><p>No data updated</p></strong>";
	}	
}

if ( isset( $_POST['token_del_ss'] ) && $_POST['token_del_ss'] == $_SESSION['cnhk']['token_del_ss'] ) {
	if ( 'delete' == $_GET['action'] ) {
		$instance = intval( $_POST['instance'] );
		$options = get_option( 'cnhk_options' );
		if ( $instance < count( $options[0] ) ) {
			echo "<h3>Slideshow: {$options[0][$instance]} </h3>";
				$slides = get_option( 'cnhk_options_slides' );
				$slide_list = array( 'name' => array(), 'title' => array(), 'link' => array(), 'date' => array() );
				for ( $i = 0; $i < count( $slides[0] ); $i++ ) {
					if ( $slides[1][$i] == $instance ) {
						array_push( $slide_list['name'], $slides[0][$i] );
						array_push( $slide_list['title'], $slides[2][$i] );
						array_push( $slide_list['link'], urldecode( $slides[3][$i] ) );
						array_push( $slide_list['date'], gmdate( "d/m/Y - h:i A", $slides[4][$i] ) . ' GMT' );
					}
				}
				echo "<table class='wp-list-table widefat'>";
				echo "<thead><th>Slides</th><th>Title</th><th>Link</th><th>Upload date</th></thead>";
				echo "<tbody>";
				if ( count( $slide_list['name'] ) > 0 ) {
					$token_snap = md5( uniqid( rand (), true ) );
					$_SESSION['cnhk']['token_snap'] = $token_snap;
					for ( $i = 0; $i < count( $slide_list['name'] ); $i++ ) {
						echo "<tr>";
						echo "<td><img src='" . CNHK_URL . "snapshot.php?source={$slide_list['name'][$i]}&key=$token_snap&type=small' alt='{$slide_list['title'][$i]}' /></td>";
						echo "<td>{$slide_list['title'][$i]}</td><td>{$slide_list['link'][$i]}</td><td>{$slide_list['date'][$i]}</td>";
						echo "</tr>";
					}			
				} else {
					echo "<tr><td colspan='4' align='center' syle='font-size: 1.2em; font-weight: bold;'><em>This slideshow does not contain any slides</em></td></tr>";
				}
				echo "</tbody>";
				echo "</table>";
			$disable = ( 0 == count( $options[0] ) ) ? "disabled='disbaled'" : '';
			
			$token_del_ss = md5( uniqid( rand (), true ) );
			$_SESSION['cnhk']['token_del_ss'] = $token_del_ss;
			
			echo "<form method='post' class='cnhk-form' action='" . CNHK_ADMIN_SETTINGS . "&action=update'>";
			echo "<input type='hidden' name='token_del_ss' value='$token_del_ss' />";
			echo "<input type='hidden' name='instance' value='$instance' /><br />";
			echo "<label><p>Are you sure to delete? <em>(All slides used in this slideshow will be set as unused)</em></p></label>";
			echo "<input type='submit' name='confirm' value='Delete' class='button-primary' $disable/>";
			echo "<a href='" . CNHK_ADMIN_SETTINGS . "&index={$instance}' class='button'>Cancel</a>";
			echo "</form>";
		}	
	} else {
		$instance = intval( $_POST['instance'] );
		$options = get_option( 'cnhk_options' );
		$slides = get_option( 'cnhk_options_slides' );
		$ss = get_option( 'cnhk_options_ss' );
		if ( $instance < count( $options[0] ) ) {
			for ( $i= 0; $i < count( $slides[0] ); $i++ ) {
				if ( $slides[1][$i] == $instance ) {
					$slides[1][$i] = -1;
				} elseif ( $slides[1][$i] > $instance ) {
					$slides[1][$i]--;
				}
			}
			$ss_index = array_search( $options[0][$instance], $ss['ss'] );
			if ( false === $ss_index ) {
				$error_notice .= "Instance of slideshow not found. No data updated.<br />";
			} else {
				array_splice( $options[0], $instance, 1 );
				array_splice( $options[1], $instance, 1 );
				array_splice( $options[2], $instance, 1 );
				array_splice( $options[3], $instance, 1 );
				array_splice( $options[4], $instance, 1 );
				array_splice( $options[5], $instance, 1 );
				array_splice( $options[6], $instance, 1 );
				array_splice( $options[7], $instance, 1 );
				array_splice( $options[8], $instance, 1 );
				array_splice( $options[9], $instance, 1 );
				array_splice( $ss['ss'], $ss_index, 1 );
				array_splice( $ss['elem'], $ss_index, 1 );
				update_option( 'cnhk_options', $options );
				update_option( 'cnhk_options_slides', $slides );
				update_option( 'cnhk_options_ss', $ss );
				$success_notice .= 'Data updated<br />';
			}
		} else {
			$error_notice .= 'No data updated<br />';
		}
	}
}

echo "<div class='wrap'><div id='icon-options-general' class='icon32'></div><h2>Settings</h2>";

if ( '' != $error_notice ) {
	echo "<div class='error'>$error_notice</div>";
}
if ( '' != $success_notice ) {
	echo "<div class='updated'>$success_notice</div>";
}

if ( ! isset( $_POST['token_del_ss'] ) || ( isset( $_POST['token_del_ss'] ) && isset( $_GET['action'] ) && 'delete' != $_GET['action']) ): ?>
<div class='cnhk-data' id='page_url'>
	<?php echo CNHK_ADMIN_SETTINGS; ?>
</div>
<form action="<?php echo CNHK_ADMIN_SETTINGS; ?>&action=new" method="post">
	<fieldset class='cnhk-form'>
		<legend>New slideshow</legend>
		<label for='cnhk_new_name'><strong>Name</strong> <em>(unique, case sensitive)</em>: </label>
		<input type='hidden' name='cnhk_token_new_ss' value='<?php
		$token_new_ss = md5( uniqid( rand (), true ) );
		$_SESSION['cnhk']['token_new_ss'] = $token_new_ss;
		echo $token_new_ss;
		?>'/>
		<input type='text' name='name' id='cnhk_new_name' style='font-size : 1.1em; width: 25%; font-weight: bold;' />
		<input type='submit' name='submit_new' class='button' value='Add slideshow' />
	</fieldset>
</form>
<div class='form-wrap'>
<?php
	$setting = get_option( 'cnhk_options' );
	$value = array( 
		'name' 				=> null,
		'effect' 			=> null,
		'transition_speed' 	=> null,
		'slide_duration' 	=> null,
		'height' 			=> null,
		'width' 			=> null,
		'fixed' 			=> null,
		'fixed_width' 		=> null,
		'fixed_align'		=> null
	);
	$size = count( $setting[0] );	
	$disabled = ( 0 == $size ) ?  " disabled='disabled'" : '';
	$index;
	if ( isset( $_GET['index'] ) ) {
		$index = intval( trim( $_GET['index'] ) );
	} else {
		$index = 0;
	}
	$disabled_fixed = ( 0 < $size && true == $setting[7][$index] ) ?   '' : " disabled='disabled'";
	if ( 0 < $size) {
		$value = array(
			'name' 				=> $setting[0][$index],
			'effect'			=> $setting[1][$index],
			'transition_speed' 	=> $setting[2][$index],
			'slide_duration' 	=> $setting[3][$index],
			'height' 			=> $setting[4][$index],
			'width' 			=> $setting[5][$index],
			'nav'				=> $setting[6][$index],
			'fixed'				=> $setting[7][$index],
			'fixed_width'		=> $setting[8][$index],
			'fixed_align'		=> $setting[9][$index],
		);
	}
	
	$checked = '';
	if ( 0 < $size && true == $value['nav'] ) $checked = ' checked';
	
	echo "<form method='post' action='" . CNHK_ADMIN_SETTINGS . "&action=delete'>";
	$token_del_ss = md5( uniqid( rand (), true ) );
	$_SESSION['cnhk']['token_del_ss'] = $token_del_ss;
	echo "<input type='hidden' name='token_del_ss' value='$token_del_ss' />";
	echo "<fieldset class='cnhk-form'>";
	echo "<legend>Choose a slideshow to edit</legend>";
	if ( 0 == $size ) {
			echo "<label for='instance'>No slideshow found.</label>";
	} else {
		echo "<label for='instance'>Existing slideshows</label>";
	}
	echo "<select name='instance' id='instance' style='font-weight: bold; font-size: 1.2em; color: #666;'>";
	if ( 0 != $size ) {
		for( $i = 0; $i < $size; $i++ ) {
			if ( $i == $index ) {
				echo "<option value='$i' selected='selected'>{$setting[0][$i]}</option>";
			} else {
				echo "<option value='$i'>{$setting[0][$i]}</option>";
			}
		}
	}
	
	echo "</select>";
	echo "<input type='submit' class='button-primary' name='del' value='Delete slideshow'$disabled />";
	echo "</fieldset>";
	echo "</form>";
	echo "<br />";
	if ( 0 < $size ) {
		echo "<form method='post' action='" . CNHK_ADMIN_SETTINGS . "&action=edit&index=$index'>";
	} else {
		echo "<form>";
	}
	echo "<fieldset class='cnhk-form'>";
	if ( 0 != $size ) echo "<legend>Settings for <em>'{$setting[0][$index]}'</em> :</legend><div id='col-container'>";
	
	echo "<div id='col-right'>";
	echo "<label for='cnhk-fixed'>Fluid / fixed width</label>";
	echo "<select name='fixed' id='cnhk-fixed'$disabled>";
	$selected_fixed0 = ( is_array( $value ) && $value['fixed'] == true ) ? " selected='selected'" : '';
	$selected_fixed1 = ( '' != $selected_fixed0 ) ? " selected='selected'" : '';
	echo "<option value='0'$selected_fixed0>Fluid width</option>";
	echo "<option value='1'$selected_fixed1>Fixed width</option>";
	echo "</select><p>Select fixed width to restrain the slideshow in a fixed width container</p>";
	echo "<label for='cnhk-fixed-width'>The fixed width</label>";
	echo "<input name='fixed-width' id='cnhk-fixed-width' type='text' value='{$value['fixed_width']}'$disabled_fixed /><em>(in pixels)</em>";
	echo "<p>Width of the container</p>";
	echo "<label for='cnhk-fixed-align'>Alignment</label>";
	echo "<select name='fixed-align' id='cnhk-fixed-align'$disabled_fixed>";
	
	$align_list = array( 'none', 'left', 'right', 'center', 'float-left', 'float-right' );
	foreach ( $align_list as $elem ) {
		$select = ( $elem == $value['fixed_align'] ) ? " selected='selected'" : '';
		echo "<option value='$elem'$select>$elem</option>";
	}
	echo "</select>";
	echo "<p>Select an alignment for the container</p>";
	echo '</div><!-- col-right -->';
	
	echo "<div id='col-left'>";
	$token_setting = md5( uniqid( rand (), true ) );
	$_SESSION['cnhk']['token_setting'] = $token_setting;
	echo "<input type='hidden' name='cnhk_token_setting' value='$token_setting' />";
	$effect_list = array( 'Scroll', 'Fade', 'None' );
	echo "<label for='effect'>Transition effect</label>";
	echo "<select name='effect' name='effect' id='effect' $disabled>";
	foreach ( $effect_list as $elem	) {
		if ( 0 != $size && $value['effect'] == $elem ) {
			echo "<option value='$elem' selected='selected'>$elem</option>";
		} else {
			echo "<option value='$elem'>$elem</option>";		
		}
	}
	echo "</select><br />";
	echo "<p>Visual effect used for switching to the next slide.</p>";
	echo "<label for='transition_speed'>Transition speed</label>";
	echo "<input type='text' name='transition_speed' id='transition_speed'";
	if ( 0 != $size ) echo " value='{$value['transition_speed']}'";
	echo "$disabled /> <em>(in milliseconds)</em><br />";
	echo "<p>Visual effect duration when switching between two slides.</p>";
	echo "<label for='slide_duration'>Slide duration</label>";
	echo "<input type='text' name='slide_duration' id='slide_duration'";
	if ( 0 != $size ) echo " value='{$value['slide_duration']}'";
	echo "$disabled /> <em>(in milliseconds)</em><br />";
	echo "<p>Display duration of each slide.</p>";
	echo "<label for='width'>Width</label>";
	echo "<input type='text' name='width' id='width'";
	if ( 0 != $size ) echo " value='{$value['width']}'";
	echo "$disabled /> <em>(in pixels)</em><br />";
	echo "<p>Width used for the slideshow's ratio.</p>";
	echo "<label for='height'>Height</label>";
	echo "<input type='text' name='height' id='height'";
	if ( 0 != $size ) echo " value='{$value['height']}'";
	echo "$disabled /> <em>(in pixels)</em><br />";
	echo "<p>Height used for the slideshow's ratio.</p>";
	echo "<span style='margin-left: 15px;'>Display navigation buttons?";
	echo "<input type='checkbox' name='nav' id='nav'$checked$disabled /></span><br />";
	echo "<p>Check if you want to display navigation buttons for this slideshow.</p>";
	echo "<input type='submit' name='submit_setting' id='submit_setting' value='Save changes ?' class='button-primary'$disabled /><br />";
	echo '<fieldset>';
	echo '</div><!-- col-left -->';
	echo "</form>";
?>
</div><!-- col-container -->
<?php endif; /* $_POST is empty */?>
</div><!-- wrap -->